using System;
using System.Runtime.InteropServices;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Windows.Forms;

namespace Kassa
{
	public class MsSqlHelper
	{
		/// <summary>
		///    
		/// </summary>
		public static string connectionString = "";
		public static string[]	connectParams;

		public static SqlConnection GetConnection()
		{
			SqlConnection conn = null;	// 

			try
			{
				conn = new SqlConnection(connectionString);
				conn.Open();
			}
			catch
			{
				conn = null;
			}

			return conn;
		}

		public static void CloseConnection(SqlConnection conn)
		{
			if (conn != null)
			{
				if (conn.State == ConnectionState.Open)
					conn.Close();
				conn.Dispose();
			}
		}

		/// <summary>
		///  
		/// </summary>
		/// <param name="accessReader">SqlDataReader</param>
		public static void CloseDataReader(SqlDataReader dr)
		{
			if ((dr != null)&&(dr.IsClosed == false))
				dr.Close();
		}

		public static bool ConnectLibraryAvailable()
		{
			return File.Exists("connect.dll");
		}

		[DllImport("connect.dll")]
		public static extern string _connect2();

		/// <summary>
		///          connectionString
		/// </summary>
		/// <returns>CANCEL:   ; ERROR:  ; OK:   Ok</returns>
		public static string Connect()
		{
			string		retVal				= "ERROR";	//  
			string		connectParamsString	= null;		//   ( )
			bool		isCancel			= false;	// 
			bool		isError				= false;	// 
			connectParams		= null;		//   ( )

			try
			{
				connectParamsString = _connect2();

				isCancel = connectParamsString.IndexOf("*CANCEL*") == -1 ? false : true;
				isError = connectParamsString.IndexOf("*ERROR*") == -1 ? false : true;
		
				if ((isCancel == false)&&(isError == false))
				{
					connectParams = connectParamsString.Split(new char[] {'*'});
					if (connectParams.GetLength(0) == 4)
					{
						connectionString =
							string.Format(
							@"data source={0};initial catalog={1};user id={2};password={3};Connect Timeout=30",
							connectParams[0],
							connectParams[1],
							connectParams[2],
							connectParams[3] );

						retVal = "OK";
					}
					else
					{
						MessageBox.Show("     (*)!", " ", MessageBoxButtons.OK, MessageBoxIcon.Error);
						retVal = "ERROR";
					}
				}
				else
				{
					if (isCancel == true)
						retVal = "CANCEL";
					else if (isError == true)
						retVal = "ERROR";
				}
			}
			catch (EntryPointNotFoundException)
			{
				retVal = "INVALID";
			}

			return retVal;
		}

		public static string GetConnectionStatus()
		{
			string			retVal	= "";	//  
			SqlConnection	conn	= null;	// SqlConnection

			try
			{
				conn = new SqlConnection(connectionString);
				conn.Open();
				retVal = "OK";
			}
			catch (Exception excError)
			{
				retVal = excError.Message;
			}
			finally
			{
				MsSqlHelper.CloseConnection(conn);
			}

			return retVal;
		}

		public const int MAX_CONNECT_RETRIES = 3;

		/// <summary>
		/// report print
		/// </summary>
		public static void printReport(int nReport)
		{
			//connection.ConnectionString
			int parameter=1;
			System.Diagnostics.Process myProcess = new System.Diagnostics.Process(); 
			myProcess.StartInfo.FileName = "FRGlobal.exe";
			if(MsSqlHelper.connectParams[3]=="")
				myProcess.StartInfo.Arguments = connectParams[0]+" "+MsSqlHelper.connectParams[1]+" "+MsSqlHelper.connectParams[2]+" "+ "NULL" + " "+nReport.ToString()+ " "+parameter.ToString();
			else
				myProcess.StartInfo.Arguments = MsSqlHelper.connectParams[0]+" "+MsSqlHelper.connectParams[1]+" "+MsSqlHelper.connectParams[2]+" "+MsSqlHelper.connectParams[3] + " "+nReport.ToString()+ " "+parameter.ToString();
			myProcess.StartInfo.UseShellExecute = false; 
	
			myProcess.Start();
		}
	}
}
